Summary: Kerberos authentication module for Apache HTTP Server 2.4.X
Name: mod_auth_kerb
Version: 5.4
Release: 1
License: BSD and MIT
Group: System Environment/Daemons
URL: http://modauthkerb.sourceforge.net/
Source0: http://downloads.sourceforge.net/modauthkerb/%{name}-%{version}.tar.gz
Source1: %{name}.conf
Source2: %{name}.conf_64
Patch0: %{name}-5.4-aix.patch
Patch1: %{name}-5.4-rcopshack.patch
Patch2: %{name}-5.4-fixes.patch
Patch3: %{name}-5.4-apache24.patch
Patch4: %{name}-5.4-makefile.patch
Patch5: %{name}-5.4-krb5.patch

BuildRequires: apr-devel >= 1.5.2, apr-util-devel >= 1.5.4
BuildRequires: httpd-devel >= 2.4.43, httpd-devel < 2.6
BuildRequires: patch
BuildRequires: krb5-devel >= 1.16.1

Requires:      apr >= 1.5.2, apr-util >= 1.5.4
Requires:      httpd >= 2.4.43, httpd < 2.6
Requires:      krb5-libs >= 1.16.1

Provides:      %{name} = %{version}-%{release}

%define _libdir64 %{_libdir}64

%description
mod_auth_kerb is a module for the Apache HTTP Server designed to
provide Kerberos authentication over HTTP.  The module supports the
Negotiate authentication method, which performs full Kerberos
authentication based on ticket exchanges.


%prep
%setup -q -n %{name}-%{version}
%patch0
export PATH=/opt/freeware/bin:$PATH
%patch1 -p1 -b .rcopshack
%patch2 -p1 -b .fixes
%patch3
%patch4 -p1
%patch5 -p1

rm -rf   /tmp/%{name}-%{version}-32bit
cp -pr . /tmp/%{name}-%{version}-32bit
rm -fr *
mv       /tmp/%{name}-%{version}-32bit 32bit
cp -pr 32bit 64bit

%build
# build on 64bit mode
cd 64bit
export OBJECT_MODE=64
export CC="/opt/freeware/bin/gcc -O2 -maix64"
export LDFLAGS="-maix64 -L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib"
export KRB5_LDFLAGS="/opt/freeware/lib/libgssapi_krb5.a /opt/freeware/lib/libkrb5.a /opt/freeware/lib/libk5crypto.a /opt/freeware/lib/libcom_err.a"
export APXS=/opt/freeware/bin/apxs_64
export PKG_CONFIG_PATH=""
./configure \
    --prefix=%{_prefix} \
    --without-krb4 \
    --with-krb5=%{_prefix} \
    --with-apache=%{_prefix}

gmake %{?_smp_mflags} 

# build on 32bit mode
cd ../32bit
export OBJECT_MODE=32
export CC="/opt/freeware/bin/gcc -O2 -maix32 -D_LARGE_FILES"
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
export APXS=/opt/freeware/bin/apxs
./configure \
    --prefix=%{_prefix} \
    --without-krb4 \
    --with-krb5=%{_prefix} \
    --with-apache=%{_prefix}

gmake %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

# install on 64bit mode
cd 64bit
export OBJECT_MODE=64
mkdir -p ${RPM_BUILD_ROOT}%{_libdir64}/httpd/modules
cp src/.libs/mod_auth_kerb.so ${RPM_BUILD_ROOT}%{_libdir64}/httpd/modules/mod_auth_kerb.so
chmod 0755 ${RPM_BUILD_ROOT}%{_libdir64}/httpd/modules/mod_auth_kerb.so

mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra
cp %{SOURCE2} ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra/auth_kerb.conf_64
chmod 0644 ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra/auth_kerb.conf_64

# install on 32bit mode
cd ../32bit
export OBJECT_MODE=32
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/httpd/modules
cp src/.libs/mod_auth_kerb.so ${RPM_BUILD_ROOT}%{_libdir}/httpd/modules/mod_auth_kerb.so
chmod 0755 ${RPM_BUILD_ROOT}%{_libdir}/httpd/modules/mod_auth_kerb.so

cp %{SOURCE1} ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra/auth_kerb.conf
chmod 0644 ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf/extra/auth_kerb.conf


%post
cat %{_sysconfdir}/httpd/conf/httpd.conf | \
  grep -v "# auth_kerb settings" | \
  grep -v "Include conf/extra/auth_kerb.conf" \
  > %{_sysconfdir}/httpd/conf/tmp_httpd.conf
mv -f %{_sysconfdir}/httpd/conf/tmp_httpd.conf %{_sysconfdir}/httpd/conf/httpd.conf
cat %{_sysconfdir}/httpd/conf/httpd.conf_64 | \
  grep -v "# auth_kerb settings" | \
  grep -v "Include conf/extra/auth_kerb.conf_64" \
  > %{_sysconfdir}/httpd/conf/tmp_httpd.conf_64
mv -f %{_sysconfdir}/httpd/conf/tmp_httpd.conf_64 %{_sysconfdir}/httpd/conf/httpd.conf_64

echo "# auth_kerb settings" >> %{_sysconfdir}/httpd/conf/httpd.conf
echo "Include conf/extra/auth_kerb.conf" >> %{_sysconfdir}/httpd/conf/httpd.conf
echo "# auth_kerb settings" >> %{_sysconfdir}/httpd/conf/httpd.conf_64
echo "Include conf/extra/auth_kerb.conf_64" >> %{_sysconfdir}/httpd/conf/httpd.conf_64
echo "Please restart your web server using: '/opt/freeware/sbin/apachectl restart'"


%postun
if [ "$1" = 0 ]; then
    cat %{_sysconfdir}/httpd/conf/httpd.conf | \
      grep -v "# auth_kerb settings" | \
      grep -v "Include conf/extra/auth_kerb.conf" \
      > %{_sysconfdir}/httpd/conf/tmp_httpd.conf
    mv -f %{_sysconfdir}/httpd/conf/tmp_httpd.conf %{_sysconfdir}/httpd/conf/httpd.conf
    cat %{_sysconfdir}/httpd/conf/httpd.conf_64 | \
      grep -v "# auth_kerb settings" | \
      grep -v "Include conf/extra/auth_kerb.conf_64" \
      > %{_sysconfdir}/httpd/conf/tmp_httpd.conf_64
    mv -f %{_sysconfdir}/httpd/conf/tmp_httpd.conf_64 %{_sysconfdir}/httpd/conf/httpd.conf_64

    echo "Please restart your web server using: '/opt/freeware/sbin/apachectl restart'"
fi


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/README
%config(noreplace) %{_sysconfdir}/httpd/conf/extra/auth_kerb.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/extra/auth_kerb.conf_64
%{_libdir}/httpd/modules/*.so
%{_libdir64}/httpd/modules/*.so


%changelog
* Wed Jul 21 2021 Reshma V Kumar <reskumar@in.ibm.com> - 5.4-1
- Initial port for AIX Toolbox

* Tue Nov 29 2016 Michael Perzl <michael@perzl.org> - 5.4-3
- recompiled against latest versions

* Tue May 28 2013 Michael Perzl <michael@perzl.org> - 5.4-2
- restructured package to better adapt to different Apache (httpd) versions

* Fri Nov 11 2011 Michael Perzl <michael@perzl.org> - 5.4-1
- first version for AIX V5.1 and higher
